unit Unit2;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,
  FMX.StdCtrls, FMX.ComboEdit, FMX.Edit, FMX.Controls.Presentation;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    ComboEdit1: TComboEdit;
    RB1: TRadioButton;
    RB2: TRadioButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { private 錾 }
    procedure SaveKey;
  public
    { public 錾 }
    findmode,findtype : integer;
    findkey : string;
  end;

var
  Form2: TForm2;

implementation

{$R *.fmx}

// N
procedure TForm2.FormShow(Sender: TObject);
begin
   findmode := 0;
   findtype := 1;
   findkey := '';
   RB1.IsChecked := True;
   ComboEdit1.SetFocus;
end;

//  ֌
procedure TForm2.Button1Click(Sender: TObject);
begin
   if (ComboEdit1.Text = '') then begin
      ComboEdit1.SetFocus;
      exit;
   end;
   findmode := 1;
   findtype := 1; if (RB2.IsChecked) then findtype := 2;
   findkey := ComboEdit1.Text;
   SaveKey;
   close;
end;

//  ֌
procedure TForm2.Button2Click(Sender: TObject);
begin
   if (ComboEdit1.Text = '') then begin
      ComboEdit1.SetFocus;
      exit;
   end;
   findmode := 2;
   findtype := 1; if (RB2.IsChecked) then findtype := 2;
   findkey := ComboEdit1.Text;
   SaveKey;
   close;
end;

// 
procedure TForm2.Button3Click(Sender: TObject);
begin
   findmode := 0;
   close;
end;

// R{GfBbgœ͂R{ꗗɓo^
procedure TForm2.SaveKey;
var
   s : string;
   i : integer;
begin
   s := ComboEdit1.Text;
   if (s <> '') then begin
      i := ComboEdit1.Items.IndexOf(s);
      if (i = -1) then begin
         if (ComboEdit1.Items.Count = 0) then
            ComboEdit1.Items.Add(s)
         else
            ComboEdit1.Items.Insert(0,s);
      end
      else if (i > 0) then begin
         ComboEdit1.Items.Delete(i);
         ComboEdit1.Items.Insert(0,s);
      end;
   end;
end;

end.
