unit Unit4;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,
  FMX.StdCtrls, FMX.TabControl, FMX.Layouts, FMX.Memo, FMX.Edit,
  UnitF;

type
  TForm4 = class(TForm)
    TabControl1: TTabControl;
    StatusBar1: TStatusBar;
    TabItem1: TTabItem;
    TabItem2: TTabItem;
    TabItem3: TTabItem;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    RB1: TRadioButton;
    RB2: TRadioButton;
    Edit2: TEdit;
    Label5: TLabel;
    GroupBox1: TGroupBox;
    ButtonPV1: TButton;
    LabelPV1: TLabel;
    ButtonPV2: TButton;
    LabelPV2: TLabel;
    ButtonPV3: TButton;
    LabelPV3: TLabel;
    ButtonPV4: TButton;
    LabelPV4: TLabel;
    ButtonPV5: TButton;
    LabelPV5: TLabel;
    OpenDialog1: TOpenDialog;
    procedure FormShow(Sender: TObject);
    procedure ButtonPV1Click(Sender: TObject);
    procedure ButtonPV2Click(Sender: TObject);
    procedure ButtonPV3Click(Sender: TObject);
    procedure ButtonPV4Click(Sender: TObject);
    procedure ButtonPV5Click(Sender: TObject);
  private
    { private 錾 }
    procedure PVClick(n:integer);
  public
    { public 錾 }
    AppPath : string;
  end;

var
  Form4: TForm4;

implementation

{$R *.fmx}

// N
procedure TForm4.FormShow(Sender: TObject);
begin
   Memo1.SelStart := 0;
   Memo1.SelLength:= 0;
   Memo2.SelStart := 0;
   Memo2.SelLength:= 0;
   if (LabelPV1.Text = '') then LabelPV1.Text := '(w)';
   if (LabelPV2.Text = '') then LabelPV2.Text := '(w)';
   if (LabelPV3.Text = '') then LabelPV3.Text := '(w)';
   if (LabelPV4.Text = '') then LabelPV4.Text := '(w)';
   if (LabelPV5.Text = '') then LabelPV5.Text := '(w)';

   Button1.SetFocus;
end;

// PVFAvP[Vw
procedure TForm4.PVClick(n:integer);
var
   cp : TComponent;
   tx : string;
begin
   cp := FindComponent('LabelPV'+IStr(n));
   tx := TLabel(cp).Text;
   if (tx = '')or(tx = '(w)') then begin
      OpenDialog1.InitialDir  := AppPath;
      OpenDialog1.FileName    := '';
   end
   else begin
      OpenDialog1.InitialDir  := ExtractFilePath(tx);
      OpenDialog1.FileName    := ExtractFileName(tx);
   end;
   if (OpenDialog1.Execute) then begin
      tx := OpenDialog1.FileName;
      TLabel(cp).Text := tx;
   end;
end;

procedure TForm4.ButtonPV1Click(Sender: TObject);
begin
   PVClick(1);
end;

procedure TForm4.ButtonPV2Click(Sender: TObject);
begin
   PVClick(2);
end;

procedure TForm4.ButtonPV3Click(Sender: TObject);
begin
   PVClick(3);
end;

procedure TForm4.ButtonPV4Click(Sender: TObject);
begin
   PVClick(4);
end;

procedure TForm4.ButtonPV5Click(Sender: TObject);
begin
   PVClick(5);
end;

end.
