unit Unit7;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,
  FMX.StdCtrls, FMX.Objects, FMX.Colors, FMX.Graphics,
  UnitF, FMX.Controls.Presentation;

type
  TForm7 = class(TForm)
    StatusBar1: TStatusBar;
    Button1: TButton;
    Button2: TButton;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    ColorBox1: TColorBox;
    procedure FormShow(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure PaintBox1DblClick(Sender: TObject);
  private
    { private 錾 }
  public
    { public 錾 }
    ColVal : Cardinal;
  end;

var
  Form7: TForm7;

implementation

{$R *.fmx}

// N
procedure TForm7.FormShow(Sender: TObject);
var
   r,g,b : integer;
begin
   ColVal := $ffffffff;
   RGB(ColVal,r,g,b);
   ColorBox1.Color:= ColVal;
   Label1.Text    := '#' + StrLow(IntToHex(r*256*256+g*256+b,6));
   Button1.SetFocus;
end;

// ʕ\
procedure TForm7.PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
var
   sx,sy,px,py,x1,y1 : Single;
   s : string;
   i,j:integer;
begin
   sx := PaintBox1.Width;
   sy := PaintBox1.Height;
   px := sx / 12;
   py := sy / 18;
   with Canvas do begin
      BeginScene;
      clear($FFFFFFFF);
      Font.Size := 10;
      x1 := 0;
      y1 := 0;
      for j:=0 to 5 do begin
         for i:=0 to 5 do begin
            Fill.Color := RGB(0,j*51,i*51);
            s := RGB(Fill.Color);
            FillRect(RectF(x1+i*px,y1+j*py, x1+(i+1)*px-1,y1+(j+1)*py-11),0,0,[],1.0);
            Fill.Color := $FF000000;
            FillText(RectF(x1+i*px,y1+(j+1)*py-11, x1+(i+1)*px-1,y1+(j+1)*py-1), s,
               false, 100, [TFillTextFlag.RightToLeft], TTextAlign.Center, TTextAlign.Center);
         end;
      end;
      x1 := 0;
      y1 := 6*py;
      for j:=0 to 5 do begin
         for i:=0 to 5 do begin
            Fill.Color := RGB(51,j*51,i*51);
            s := RGB(Fill.Color);
            FillRect(RectF(x1+i*px,y1+j*py, x1+(i+1)*px-1,y1+(j+1)*py-11),0,0,[],1.0);
            Fill.Color := $FF000000;
            FillText(RectF(x1+i*px,y1+(j+1)*py-11, x1+(i+1)*px-1,y1+(j+1)*py-1), s,
               false, 100, [TFillTextFlag.RightToLeft], TTextAlign.Center, TTextAlign.Center);
         end;
      end;
      x1 := 0;
      y1 := 12*py;
      for j:=0 to 5 do begin
         for i:=0 to 5 do begin
            Fill.Color := RGB(2*51,j*51,i*51);
            s := RGB(Fill.Color);
            FillRect(RectF(x1+i*px,y1+j*py, x1+(i+1)*px-1,y1+(j+1)*py-11),0,0,[],1.0);
            Fill.Color := $FF000000;
            FillText(RectF(x1+i*px,y1+(j+1)*py-11, x1+(i+1)*px-1,y1+(j+1)*py-1), s,
               false, 100, [TFillTextFlag.RightToLeft], TTextAlign.Center, TTextAlign.Center);
         end;
      end;
      x1 := 6*px;
      y1 := 0;
      for j:=0 to 5 do begin
         for i:=0 to 5 do begin
            Fill.Color := RGB(3*51,j*51,i*51);
            s := RGB(Fill.Color);
            FillRect(RectF(x1+i*px,y1+j*py, x1+(i+1)*px-1,y1+(j+1)*py-11),0,0,[],1.0);
            Fill.Color := $FF000000;
            FillText(RectF(x1+i*px,y1+(j+1)*py-11, x1+(i+1)*px-1,y1+(j+1)*py-1), s,
               false, 100, [TFillTextFlag.RightToLeft], TTextAlign.Center, TTextAlign.Center);
         end;
      end;
      x1 := 6*px;
      y1 := 6*py;
      for j:=0 to 5 do begin
         for i:=0 to 5 do begin
            Fill.Color := RGB(4*51,j*51,i*51);
            s := RGB(Fill.Color);
            FillRect(RectF(x1+i*px,y1+j*py, x1+(i+1)*px-1,y1+(j+1)*py-11),0,0,[],1.0);
            Fill.Color := $FF000000;
            FillText(RectF(x1+i*px,y1+(j+1)*py-11, x1+(i+1)*px-1,y1+(j+1)*py-1), s,
               false, 100, [TFillTextFlag.RightToLeft], TTextAlign.Center, TTextAlign.Center);
         end;
      end;
      x1 := 6*px;
      y1 := 12*py;
      for j:=0 to 5 do begin
         for i:=0 to 5 do begin
            Fill.Color := RGB(5*51,j*51,i*51);
            s := RGB(Fill.Color);
            FillRect(RectF(x1+i*px,y1+j*py, x1+(i+1)*px-1,y1+(j+1)*py-11),0,0,[],1.0);
            Fill.Color := $FF000000;
            FillText(RectF(x1+i*px,y1+(j+1)*py-11, x1+(i+1)*px-1,y1+(j+1)*py-1), s,
               false, 100, [TFillTextFlag.RightToLeft], TTextAlign.Center, TTextAlign.Center);
         end;
      end;

      EndScene;
   end;
end;

// }EXw莞
procedure TForm7.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
   sx,sy,px,py : Single;
   nx,ny : integer;
   r,g,b : integer;
begin
   sx := PaintBox1.Width;
   sy := PaintBox1.Height;
   px := sx / 12;
   py := sy / 18;
   nx := Trunc(X/px);   if (nx > 11) then nx := 11;
   ny := Trunc(Y/py);   if (ny > 17) then ny := 17;
   if (nx < 6) then begin
      if (ny < 6) then begin
         r := 0;
         g := ny*51;
         b := nx*51;
      end
      else if (ny < 12) then begin
         r := 51;
         g := (ny-6)*51;
         b := nx*51;
      end
      else begin
         r := 2*51;
         g := (ny-12)*51;
         b := nx*51;
      end;
   end
   else begin
      if (ny < 6) then begin
         r := 3*51;
         g := ny*51;
         b := (nx-6)*51;
      end
      else if (ny < 12) then begin
         r := 4*51;
         g := (ny-6)*51;
         b := (nx-6)*51;
      end
      else begin
         r := 5*51;
         g := (ny-12)*51;
         b := (nx-6)*51;
      end;
   end;

   ColVal := RGB(r,g,b);
   ColorBox1.Color:= ColVal;
   Label1.Text    := '#' + StrLow(IntToHex(r*256*256+g*256+b,6));
end;

procedure TForm7.PaintBox1DblClick(Sender: TObject);
begin
   ModalResult := mrOK;
end;

end.
