unit Unit8;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,
  FMX.StdCtrls, UnitF, FMX.Colors;

type
  TForm8 = class(TForm)
    StatusBar1: TStatusBar;
    Button1: TButton;
    Button2: TButton;
    ColorBox1: TColorBox;
    Label1: TLabel;
    ColorPanel1: TColorPanel;
    procedure FormShow(Sender: TObject);
    procedure ColorPanel1Change(Sender: TObject);
  private
    { private 錾 }
  public
    { public 錾 }
    ColVal : Cardinal;
  end;

var
  Form8: TForm8;

implementation

{$R *.fmx}

// N
procedure TForm8.FormShow(Sender: TObject);
var
   r,g,b : integer;
begin
   ColVal := $ffffffff;
   RGB(ColVal,r,g,b);
   ColorBox1.Color   := ColVal;
   ColorPanel1.Color := ColVal;
   Label1.Text := '#' + StrLow(IntToHex(r*256*256+g*256+b,6));
   Button1.SetFocus;
end;

// J[plύX
procedure TForm8.ColorPanel1Change(Sender: TObject);
begin
   ColVal := ColorPanel1.Color;
   ColorBox1.Color := ColVal;
   Label1.Text := '#' + RGB(ColVal);
end;

end.
